#pragma once
#include "olcPixelGameEngine.h"
#include "Unit.h"
#include "olcPGEX_TransformedView.h"
#include "Resources.h"

class Textbox{
	std::string headerText=""; //If a textbox has a header, it displays at the top in a special color.
	std::string text="";
	std::string displayText="";
	vf2d pos={};
	vf2d maxSize={};
	float lastLetterTime=0;
	float letterDisplayDelay=0.01;
	int textboxMarker=-1;
	int lastWordMarker=-1;
	std::string lastWord="";
	std::vector<Memory> resourceCost; //If resource cost is greater than 0, shows them.
	bool visible=true;
public:
	Textbox();
	void Initialize(std::string text,vf2d pos,std::string headerText="",vf2d maxSize={120,64},std::vector<Memory>resourceCost={},float letterDisplayDelay=0.01);

	void UpdateAndDraw(vf2d pos,PixelGameEngine*pge,Resources&resources);
	std::string&GetCurrentString();
	void SetVisible(bool visible);
private:
	void Update(PixelGameEngine*pge);
	void UpdatePosition(vf2d newPos);
	void Draw(PixelGameEngine*pge,Resources&resources);
	void SetDefaults();
};